﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.Windows.Forms.Chart;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        ChartControl chart = new ChartControl();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            List<chartData> data = new List<chartData>();
            List<XY> filteredData = new List<XY>();
            DateTime date1 = new DateTime(2017, 1, 8, 1, 1,1);
            DateTime date2 = new DateTime(2017, 1, 9, 2, 2,2);
            for(int i=1; i<=24;i++){
                if(i<13)
                   data.Add(new chartData( i, i+1, new DateTime(2017, 1, 1, 1, i + 1, 1), new DateTime(2017, 1, 1, 1, i+ 3, 1), date1, new DateTime(2017, 1, i + 2, 1, 1, 1)));
                else
                   data.Add(new chartData(i-12, i + 1, new DateTime(2017, 1, 1, 1, i + 1, 1), new DateTime(2017, 1, 1, 1, i + 3, 1), date2, new DateTime(2017, 1, i + 2, 1, 1, 1)));
            }

            var filter = data.Select(x=>x.employee_Id).Distinct().ToList();
            this.chart.PrimaryXAxis.ValueType = ChartValueType.DateTime;
            this.chart.PrimaryYAxis.ValueType = ChartValueType.DateTime;
            this.chart.PrimaryXAxis.DateTimeFormat = "HH:mm";
            this.chart.PrimaryYAxis.IntervalType = ChartDateTimeIntervalType.Days;
            this.chart.PrimaryXAxis.IntervalType = ChartDateTimeIntervalType.Minutes;
            this.chart.PrimaryYAxis.DateTimeFormat = "dd";
             this.chart.Title.Text = "Working Time";
            this.chart.PrimaryYAxis.Title = "Date";
            this.chart.PrimaryXAxis.Title = "Time";
            this.chart.LegendPosition = ChartDock.Top;
            Color[] sereisColor = { Color.Orange, Color.Blue, Color.Red, Color.Red, Color.White, Color.BlueViolet, Color.White, Color.Green, Color.Red, Color.White, Color.Red, Color.Gray };
            string[] seriesName = new string[12] { "WAS TED" ,"HTC 7020","WAS TED","HTC 7061","BREAK","HTC 7061","LUNCH BREAK", "HTC 7061","NO INPU","Evening Br","Wasted","HTC 7128"};
            for (int j = 0; j < filter.Count; j++) {
                
                ChartSeries series = new ChartSeries(seriesName[j]);
                series.Type = ChartSeriesType.StackingBar;
                DateTime[] xData2 = data.Where(x => x.employee_Id == filter[j]).Select(x => x.date_Start).ToArray();
                DateTime[] yData2 = data.Where(x => x.employee_Id == filter[j]).Select(x => x.time_Start).ToArray();
                for(int k=0; k<xData2.Length;k++){
                    series.Points.Add(xData2[k], yData2[k].ToOADate());
                }
                series.Style.Interior = new Syncfusion.Drawing.BrushInfo(sereisColor[j]);
                this.chart.Series.Add(series);
            }
            this.chart.ShowToolbar = true;
            this.chart.Size = new Size(800, 450);
            this.Controls.Add(chart);
        }

    }
    public class XY
    {
        public DateTime X { get; set; }
        public DateTime Y { get; set; }
    }
    public class chartData
    {
        public chartData(double employee_id, double Product_id, DateTime time_start, DateTime time_finish, DateTime date_start, DateTime date_finish)
        {
            this.employee_Id = employee_id;
            this.Product_Id = Product_id;
            this.time_Start = time_start;
            this.time_Finish = time_finish;
            this.date_Start = date_start;
            this.date_Finish = date_finish;
        }
        public double employee_Id
        {
            get;
            set;
        }
        public double Product_Id
        {
            get;
            set;
        }
        public DateTime time_Start
        {
            get;
            set;
        }
        public DateTime time_Finish
        {
            get;
            set;
        }
        public DateTime date_Start
        {
            get;
            set;
        }
        public DateTime date_Finish
        {
            get;
            set;
        }

    }
}
